#ifndef _INCLUDED_ConstrainedRectCalculator_H
#define _INCLUDED_ConstrainedRectCalculator_H

#include "RectCalculator.h"

@interface ConstrainedRectCalculator : RectCalculator
{
    // Parameter _a is used for particular size selection withing
    // the interval between the minimal and maximal rectangle size
    // (in x axis direction). If minimal rectangle size is bigger than _a
    // then the maximal size is chosen (i.e. minimal size is big enough)
    // which let the mouse pointer be on the edge of the selected rectangle.
    float _a;

    // Experimental: filter to smoother size changes while mouse tracking
    id _filter;
}

- (void) dealloc;
- (id) initWithTracker: (MouseTracker *) tracker mouse: (NSPoint) pt;
- (id) initWithTracker: (MouseTracker *) tracker mouse: (NSPoint) pt
                 start: (NSPoint) start end: (NSPoint) end;
- (NSPoint) correctEndPointFromStart: (NSPoint) start end: (NSPoint) end;

@end

#endif // _INCLUDED_ConstrainedRectCalculator_H
