#include "CursorRectInfo.h"
#include <AppKit/NSCursor.h>
#include <AppKit/NSView.h>

@implementation CursorRectInfo

+ (id) infoWithRect: (NSRect) rc cursor: (NSCursor *) cursor
{
    CursorRectInfo * obj =
        [[CursorRectInfo alloc] initWithRect: rc cursor: cursor];
    return AUTORELEASE(obj);
}

- (id) initWithRect: (NSRect) rc cursor: (NSCursor *) cursor
{
    _rc = rc;
    _cursor = cursor;
    RETAIN(_cursor);
    return self;
}

- (void) dealloc
{
    RELEASE(_cursor);
    [super dealloc];
}

- (void) addToView: (NSView *) view
{
    [view addCursorRect: _rc cursor: _cursor];
}


@end // CursorRectInfo
