#ifndef _INCLUDED_Fragment_H
#define _INCLUDED_Fragment_H

#include <Foundation/NSObject.h>
#include <Foundation/NSGeometry.h>

@class NSImage;

@interface Fragment : NSObject
{
    NSRect _scene;
    int _rotation;
}

+ (id) fragmentWithScene: (NSRect) scene;
+ (id) fragmentWithScene: (NSRect) scene
                rotation: (int) degrees;
+ (id) fragmentWithImage: (NSImage *) image;
+ (id) fragmentWithImage: (NSImage *) image
                rotation: (int) degrees;

- (id) init;
- (id) initWithScene: (NSRect) scene;
- (id) initWithScene: (NSRect) scene
            rotation: (int) degrees;
- (id) initWithImage: (NSImage *) image;
- (id) initWithImage: (NSImage *) image
            rotation: (int) degrees;

- (NSRect) scene;
- (void) setScene: (NSRect) scene;
- (int) span;

- (int) rotation;
- (void) setRotation: (int) degrees;

- (float) scaleFor: (int) requiredSpan;

@end // @interface Fragment

#endif // _INCLUDED_Fragment_H
