#include "LowPassFilter.h"

@implementation LowPassFilter

- init
{
    [self initWithValue: 0];
    return self;
}

- initWithValue: (float) value
{
    int i;
    accum = value * AVG_LEN;
    for (i=0; i < AVG_LEN; ++i)
        rec[i] = value;
    return self;
}

// returns filtered value
- (float) addNewValue: (float) value
{
    int i;
    float old = rec[0];
    for (i=1; i < AVG_LEN; ++i)
        rec[i-1] = rec[i];
    rec[AVG_LEN-1] = value;
    accum += (value - old);

    return accum / AVG_LEN;
}

- (float) filteredValue
{
    return accum / AVG_LEN;
}

@end // LowPassFilter
