#ifndef _INCLUDED_MouseTracker_H
#define _INCLUDED_MouseTracker_H

#include <Foundation/NSGeometry.h>
#include "PHGeometry.h"

@class NSCursor;
@class RectCalculator;

@interface MouseTracker : NSObject
{
    NSRect _frame;
    float _shape;
}

- (id) initWithFrame: (NSRect) frame selRect: (NSRect) selRect
               start: (NSPoint) pt;
- (id) initWithFrame: (NSRect) frame;
- (NSRect) mouseDown: (NSPoint) pt;
- (NSRect) mouseDragged: (NSPoint) pt;
- (NSRect) selectionRect;

- (NSCursor *) cursor;

- (NSRect) frame;
- (float) shape;

@end // @interface MouseTracker


@interface MouseTrackerNewSel: MouseTracker
{
    NSPoint _start;
    NSPoint _end;

    RectCalculator * _calc;
}

- (void) dealloc;
- (NSRect) mouseDown: (NSPoint) pt;
- (NSRect) mouseDragged: (NSPoint) pt;
- (NSRect) selectionRect;

+ (NSCursor *) cursorType;

@end

@interface MouseTrackerMoveCorner: MouseTrackerNewSel
{
    Vect2D _pt_to_end;
}

- (id) initWithFrame: (NSRect) frame selRect: (NSRect) selRect
               start: (NSPoint) pt;
- (NSRect) mouseDown: (NSPoint) pt;
- (NSRect) mouseDragged: (NSPoint) pt;

+ (NSCursor *) cursorType;

@end

@interface MouseTrackerMoveAll: MouseTracker
{
    NSRect _selRect;
    NSPoint _start;
}

- (id) initWithFrame: (NSRect) frame selRect: (NSRect) selRect
               start: (NSPoint) pt;
- (NSRect) mouseDown: (NSPoint) pt;
- (NSRect) mouseDragged: (NSPoint) pt;
- (NSRect) selectionRect;

+ (NSCursor *) cursorType;

@end

#endif // _INCLUDED_MouseTracker_H
