#ifndef _INCLUDED_PHIMAGE_H_
#define _INCLUDED_PHIMAGE_H_

#include <Foundation/NSGeometry.h>
#include <AppKit/NSImage.h>

@class NSAffineTransform;

@interface NSImage (PhotoClip)

- (NSImage *) imageFromRect: (NSRect) rect;

- (NSImage *) imageTransformedBy: (NSAffineTransform *) transform;

- (NSImage *) imageFromRect: (NSRect) rect
              transformedBy: (NSAffineTransform *) transform;

- (NSImage *) imageFromRect: (NSRect) rect
                   scaledBy: (float) scale
                  rotatedBy: (float) degrees;

- (NSImage *) imageFromRect: (NSRect) rect
                  rotatedBy: (float) degrees;

// - (NSAffineTransform *) transformFromRotation: (float) degrees
//                                       scale: (float) scale;

- (NSImage *) imageMadeFromRect: (NSRect) rect
                   scaledToSpan: (int) span
                      rotatedBy: (float) degrees;

- (NSRect) rect;

- (NSBitmapImageRep *) bitmapRepresentation;


- (void) moveBitsFromSrcRep: (NSBitmapImageRep *) src
                    srcRect: (NSRect) src_rect
                  toDestRep: (NSBitmapImageRep *) dest
                    scaleBy: (float) scale
                   rotateBy: (float) degrees;

- (NSSize) jpegBlockSize;

@end

#endif // _INCLUDED_PHIMAGE_H_
