#ifndef _INCLUDED_PICTURE_VIEW_H
#define _INCLUDED_PICTURE_VIEW_H

#include <Foundation/NSGeometry.h>
#include <AppKit/NSView.h>
#include <AppKit/NSImageView.h>
#include "PHDefs.h"

@class Selection;
@class Fragment;
@class Stack;

@interface PictureView : NSView
{
    NSImage * _image;
    NSImage * _sketch;
    
    int _rotation;

    Fragment * _fragm;
    Stack * _fragms;

    // redundant, can be determined from _fragm and current frame
    NSAffineTransform * _fragmToSketch;

    Selection * _selection;

    // I do not like it to be here, but I try Selection to work
    // solely in the sketch cooridnates. Need to move it eventually somewhere.
    NSRect _selectedInImage; // image coordinated

}

- (id) initWithFrame: (NSRect) rect;
- (void) setImage: (NSImage *) image;
- (NSImage *) image;

- (void) setRotationTo: (float) degrees;
- (void) rotateWithDirection: (PHRotateDirection) direction;

- (Fragment *) fragmentToSave;

// Interface towards Selection

- (NSSize) imageSize;                   // image coord
- (NSRect) scene;                       // image coord
- (NSSize) sketchSize;                  // sketch coord
- (NSAffineTransform *) fragmToSketch;


@end // @interface PictureView

#endif // _INCLUDED_PICTURE_VIEW_H
