#ifndef _INCLUDED_RectCalculator_H
#define _INCLUDED_RectCalculator_H

#include <Foundation/NSObject.h>
#include <Foundation/NSGeometry.h>
#include "PHGeometry.h"

@class MouseTracker;

@interface RectCalculator : NSObject
{
    MouseTracker * _tracker;
    Vect2D _mouse_to_end;
}

- (id) initWithTracker: (MouseTracker *) tracker;

// New Selection
- (id) initWithTracker: (MouseTracker *) tracker mouse: (NSPoint) pt;

// Move Corner
- (id) initWithTracker: (MouseTracker *) tracker mouse: (NSPoint) pt
                 start: (NSPoint) start end: (NSPoint) end;

- (Vect2D) mouseToEndOffset;
- (NSPoint) correctEndPointFromStart: (NSPoint) start end: (NSPoint) end;

@end

#endif // _INCLUDED_RectCalculator_H
