#include "RectCalculator.h"
#include <Foundation/NSException.h>
#include "MouseTracker.h"

@implementation RectCalculator

- (id) initWithTracker: (MouseTracker *) tracker
{
    [super init];
    _tracker = tracker;
    _mouse_to_end = PHMakeVect2D(0,0);
    return self;
}

- (id) initWithTracker: (MouseTracker *) tracker mouse: (NSPoint) pt
{
    NSAssert(0, @"Must be abstract");
    return self;
}

- (id) initWithTracker: (MouseTracker *) tracker mouse: (NSPoint) pt
                 start: (NSPoint) start end: (NSPoint) end
{
    NSAssert(0, @"Must be abstract");
    return self;
}

- (Vect2D) mouseToEndOffset
{
    return _mouse_to_end;
}

- (NSPoint) correctEndPointFromStart: (NSPoint) start end: (NSPoint) end
{
    NSAssert(0, @"Must be abstract");
    return NSZeroPoint;
}

@end // RectCalculator
