#include "Stack.h"
#include <Foundation/NSArray.h>

@implementation Stack

- (id) init
{
    [super init];
    _rep = [[NSMutableArray alloc] init];
    if ( _rep == nil )
    {
        [self dealloc];
        return nil;
    }
    return self;
}

- (id) initWithObject: (id) object
{
    [super init];
    _rep = [[NSMutableArray alloc] initWithCapacity: 1];
    if ( _rep == nil )
    {
        [self dealloc];
        return nil;
    }
    
    [self push: object];
    return self;
    
}

- (void) dealloc
{
    RELEASE(_rep);
    [super dealloc];
}

- (void) push: (id) object
{
    [_rep addObject: object];
}

- (id) pop
{
    if ([self empty])
        return nil;
    
    NSObject * obj = [_rep lastObject];
    RETAIN(obj);

    [_rep removeLastObject];

    return AUTORELEASE(obj);
}

- (void) removeAllObjects
{
    [_rep removeAllObjects];
}

- (id) top
{
    if ([self empty])
        return nil;
    return [_rep lastObject];
}

- (int) depth
{
    return [_rep count];
}

- (BOOL) empty
{
    return [_rep count] == 0;
}

@end // @implementation Stack
