#include "UnconstrainedRectCalculator.h"
#include "MouseTracker.h"

@implementation UnconstrainedRectCalculator

- (id) initWithTracker: (MouseTracker *) tracker mouse: (NSPoint) pt
{
    // New Selection
    [super initWithTracker: tracker];
    return self;
}

- (id) initWithTracker: (MouseTracker *) tracker mouse: (NSPoint) pt
                 start: (NSPoint) start end: (NSPoint) end
{
    // Move Corner
    [super initWithTracker: tracker];
    _mouse_to_end = PHMakeVect2D(end.x - pt.x, end.y - pt.y);
    return self;
}

- (NSPoint) correctEndPointFromStart: (NSPoint) start end: (NSPoint) end
{
    return PHClosestPointInRect(end, [_tracker frame]);
}

@end // UnconstrainedRectCalculator
