#include "mem.h"
#include <stdlib.h>
#include <string.h>

float *** fmatrix3d( int x, int y, int z )
{
    int i, j;
    int len1 = x * sizeof( float **);
    int len2 = y * sizeof( float * );
    int len3 = z * sizeof( float );

    float *** m = malloc( len1 );
    if ( !m )
        return 0;

    memset( m, 0, len1 ); 

    for ( i = 0; i < x; ++i )
    {
        
        m[i] = malloc( len2 );
        if ( !m[i] )
            goto nomem;
        memset( m[i], 0, len2 );

        for ( j=0; j < y; ++j )
        {
            m[i][j] = malloc( len3 );
            if ( ! m[i][j] )
                goto nomem;
            memset( m[i][j], 0, len3 );
        }
    }

    return m;

 nomem:
    free_fmatrix3d(m, x, y, z);
    return 0;
}

void free_fmatrix3d( float *** m, int x, int y, int z )
{
    int i, j;
    for ( i = 0; i < x; ++i )
    {
        if ( m[i] )
            for ( j=0; j < y; ++j )
                free( m[i][j] );
        free( m[i] );
    }
    free( m );
}
